CREATE PROCEDURE [sp_Get_Customers_By_Page]
 @CurrentPage int,
 @PageSize int,
 @TotalRecs int output
AS
 --Create a temp table to hold the current page of data
 --Add and ID column to count the records
 CREATE TABLE #TempTable
 (
  ID int IDENTITY PRIMARY KEY,
  CompanyName nvarchar(40),
  ContactName nvarchar (30),
  ContactTitle nvarchar (30),
  Phone nvarchar (24),
  Fax nvarchar (24)
 )
 --Fill the temp table with the Customers data
 INSERT INTO #TempTable (CompanyName, ContactName, ContactTitle, Phone, Fax)
 SELECT CompanyName, ContactName, ContactTitle, Phone, Fax FROM Customers
 --Create variable to identify the first and last record that should be selected
 DECLARE @FirstRec int, @LastRec int
 SELECT @FirstRec = (@CurrentPage - 1) * @PageSize
 SELECT @LastRec = (@CurrentPage * @PageSize + 1)
 --Select one page of data based on the record numbers above
 SELECT CompanyName, ContactName, ContactTitle, Phone, Fax
 FROM #TempTable
 WHERE ID > @FirstRec AND ID < @LastRec
 --Return the total number of records available as an output parameter
 SELECT @TotalRecs = COUNT(*) FROM Customers
