using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;

public class Listing0609 : Page{

  protected DataGrid myDataGrid;
  protected Label CurrentPage;
  protected Label TotalPages;
  protected LinkButton NextPage;
  protected LinkButton PreviousPage;
  protected LinkButton FirstPage;
  protected LinkButton LastPage;
  protected int CurrentPageNumber;

  protected void Page_Load(Object sender, EventArgs e){
   if (!Page.IsPostBack){
     CurrentPageNumber = 1;
     BindData();
   }
  }

  protected void BindData(){
   SqlConnection myConnection = new SqlConnection("server=localhost;database=Northwind;uid=sa;pwd=;");
   SqlCommand myCommand = new SqlCommand("sp_Get_Customers_By_Page", myConnection);
   SqlDataReader myReader = null;
   
   
   myCommand.CommandType = CommandType.StoredProcedure;
   myCommand.Parameters.Add(new SqlParameter("@CurrentPage", SqlDbType.Int));
   myCommand.Parameters["@CurrentPage"].Value = CurrentPageNumber;
   myCommand.Parameters.Add(new SqlParameter("@PageSize", SqlDbType.Int));
   myCommand.Parameters["@PageSize"].Value = myDataGrid.PageSize;   
   myCommand.Parameters.Add(new SqlParameter("@TotalRecs", SqlDbType.Int));
   myCommand.Parameters["@TotalRecs"].Direction = ParameterDirection.Output;
   
   
   try{
    myConnection.Open();
    myReader = myCommand.ExecuteReader();
    myDataGrid.DataSource = myReader;
    myDataGrid.DataBind();
   }
   finally{
    myConnection.Close();
   }

   CurrentPage.Text = CurrentPageNumber.ToString();

   if (!Page.IsPostBack){
    int Total_Records = ((int) myCommand.Parameters["@TotalRecs"].Value);
    decimal Total_Pages = Decimal.Parse(Total_Records.ToString())/myDataGrid.PageSize;
    TotalPages.Text = (System.Math.Ceiling(Double.Parse(Total_Pages.ToString()))).ToString();
   }

   if(CurrentPageNumber == 1){
    PreviousPage.Enabled = false;
    NextPage.Enabled=true;
   }else{
    if(CurrentPageNumber == Int32.Parse(TotalPages.Text)){
     NextPage.Enabled=false;
     PreviousPage.Enabled=true;
    }else{
     PreviousPage.Enabled=true;
     NextPage.Enabled=true;
    }
   }
  }

  protected void NavigationLink_OnClick(Object sender, CommandEventArgs e){
   switch (e.CommandName){
    case "First":
     CurrentPageNumber = 1;
     break;
    case "Last":
     CurrentPageNumber = Int32.Parse(TotalPages.Text);
     break;
    case "Next":
     CurrentPageNumber = Int32.Parse(CurrentPage.Text) +1;
     break;
    case "Prev":
     CurrentPageNumber = Int32.Parse(CurrentPage.Text) -1;
     break;
    }
    
    BindData();
    
  }
  
}