Imports System
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Data
Imports System.Data.SqlClient

Public Class Listing0609 : Inherits Page

  Protected myDataGrid As DataGrid
  Protected CurrentPage As Label
  Protected TotalPages As Label
  Protected NextPage As LinkButton
  Protected PreviousPage As LinkButton
  Protected FirstPage As LinkButton
  Protected LastPage As LinkButton
  Protected CurrentPageNumber As Integer

  Sub Page_Load(Sender As Object, E As EventArgs)
   If Not Page.IsPostBack Then
     CurrentPageNumber = 1
     BindData()
   End If
  End Sub

  Sub BindData()
   Dim myConnection As SqlConnection = new SqlConnection("server=localhost;database=Northwind;uid=sa;pwd=;")
   Dim myCommand As SqlCommand = new SqlCommand("sp_Get_Customers_By_Page", myConnection)
   Dim myReader As SqlDataReader = Nothing
   
   With myCommand
     .CommandType = CommandType.StoredProcedure
     .Parameters.Add(new SqlParameter("@CurrentPage", SqlDbType.Int))
     .Parameters("@CurrentPage").Value = CurrentPageNumber
     .Parameters.Add(new SqlParameter("@PageSize", SqlDbType.Int))
     .Parameters("@PageSize").Value = myDataGrid.PageSize
     .Parameters.Add(new SqlParameter("@TotalRecs", SqlDbType.Int))
     .Parameters("@TotalRecs").Direction = ParameterDirection.Output
   End With
   
   Try
    myConnection.Open()
    myReader = myCommand.ExecuteReader()
    myDataGrid.DataSource = myReader
    myDataGrid.DataBind()
    
   Finally
    myConnection.Close()
   End Try

   CurrentPage.Text = CurrentPageNumber.ToString()

   If Not Page.IsPostBack Then
    Dim Total_Records As Integer = CInt(myCommand.Parameters("@TotalRecs").Value)
    Dim Total_Pages As Decimal = Decimal.Parse(Total_Records.ToString())/myDataGrid.PageSize
    TotalPages.Text = (System.Math.Ceiling(Double.Parse(Total_Pages.ToString()))).ToString()
   End If

   Select Case CurrentPageNumber
    Case 1
     PreviousPage.Enabled = False
     NextPage.Enabled = True
    Case Int32.Parse(TotalPages.Text)
     NextPage.Enabled = False
     PreviousPage.Enabled = True
    Case Else
     PreviousPage.Enabled = True
     NextPage.Enabled = True
   End Select
   
  End Sub

  Sub NavigationLink_OnClick(Sender As Object, E As CommandEventArgs)
   Select Case e.CommandName
    Case "First"
     CurrentPageNumber = 1
     
    Case "Last"
     CurrentPageNumber = Int32.Parse(TotalPages.Text)
     
    Case "Next"
     CurrentPageNumber = Int32.Parse(CurrentPage.Text) +1
     
    Case "Prev"
     CurrentPageNumber = Int32.Parse(CurrentPage.Text) -1
     
    End Select
    
    BindData()
    
  End Sub

End Class