<%@ import namespace="System.Data" %>
<%@ import namespace="System.Data.SqlClient" %>

<script language="C#" runat="Server">

 protected void Page_Load(Object sender, EventArgs e){

  if (! Page.IsPostBack) {

   Bind();

  }

 }

 void SaveToSession(DataSet ds){

  Session["WorkingDataSet"] = ds;

 }

 DataSet GetFromSession() {

  return (DataSet)Session["WorkingDataSet"];

 }

 void Bind(){

  if (Session["WorkingDataSet"] == null) {

   DDLSuppliers.DataSource = GetFromDatabase().Tables["Suppliers"];

  } else {

   DDLSuppliers.DataSource = GetFromSession().Tables["Suppliers"];

  }

   Page.DataBind();
   GetProducts();

 }

 DataSet GetFromDatabase(){

  SqlConnection SqlCon = new SqlConnection("server=localhost;uid=sa;pwd=;database=northwind");
  SqlDataAdapter SqlDA = new SqlDataAdapter("SELECT ProductName, ProductID, SupplierID FROM Products ORDER By ProductName", SqlCon);

  SqlDA.UpdateCommand = new SqlCommand("UPDATE Products SET ProductName = @ProductName WHERE ProductID = @ProductID");
  SqlDA.UpdateCommand.Parameters.Add(new SqlParameter("@ProductName", SqlDbType.NVarChar, 20, "ProductName"));
  SqlDA.UpdateCommand.Parameters.Add(new SqlParameter("@ProductID", SqlDbType.Int, 4, "ProductID"));

  SqlDA.InsertCommand = new SqlCommand("INSERT INTO Products (ProductName, SupplierID) VALUES (@ProductName,@SupplierID)");
  SqlDA.InsertCommand.Parameters.Add(new SqlParameter("@ProductName", SqlDbType.NVarChar, 20, "ProductName"));
  SqlDA.InsertCommand.Parameters.Add(new SqlParameter("@SupplierID", SqlDbType.Int, 4, "SupplierID"));

  SqlDA.DeleteCommand = new SqlCommand("DELETE Products WHERE ProductID = @ProductID");
  SqlDA.DeleteCommand.Parameters.Add(new SqlParameter("@ProductID", SqlDbType.Int, 4, "ProductID"));

  DataSet ds = new DataSet();
  SqlDA.Fill(ds, "Products");

  SqlDA.SelectCommand = new SqlCommand("SELECT CompanyName, SupplierID FROM Suppliers ORDER BY CompanyName", SqlCon);
  SqlDA.Fill(ds, "Suppliers");

  SaveToSession(ds);
  Session["WorkingDataAdpater"] = SqlDA;
  SqlCon.Close();

  return ds;

 }

 protected void GetProducts_Click(Object sender, EventArgs e){ GetProducts(); }

 protected void GetProducts(){

  lbProducts.Items.Clear();

  DataView dv = new DataView(GetFromSession().Tables["Products"]);
  dv.Sort = DDLColumn.SelectedItem.Value + " " + DDLSortOrder.SelectedItem.Value;
  dv.RowFilter = "SupplierID =" + DDLSuppliers.SelectedItem.Value;
  lbProducts.SelectedIndex = 0;
  lbProducts.DataSource = dv;
  lbProducts.DataBind();
  txtEdit.Text = null;
 }


 protected void Delete_Click(Object sender, EventArgs e){

  DataSet ds = GetFromSession();
  DataTable dt = ds.Tables["Products"];
  DataRow[] dr = dt.Select("ProductID = " + lbProducts.SelectedItem.Value);
  dr[0].Delete();
  SaveToSession(ds);
  GetProducts();

 }

 protected void Insert_Click(Object sender, EventArgs e){

  DataSet ds = GetFromSession();
  DataTable dt = ds.Tables["Products"];
  DataRow dr = dt.NewRow();
  dr["ProductName"]  =txtEdit.Text;
  dr["SupplierID"] = DDLSuppliers.SelectedItem.Value;
  Random RA = new Random();
  string sProductID = "1234" + RA.Next(1000).ToString();
  dr["ProductID"] = int.Parse(sProductID);
  dt.Rows.Add(dr);
  SaveToSession(ds);
  GetProducts();

 }

 protected void Edit_Click(Object sender, EventArgs e){

  DataSet ds = GetFromSession();
  DataTable dt = ds.Tables["Products"];
  DataRow[] dr = dt.Select("ProductID = " + lbProducts.SelectedItem.Value);
  dr[0].BeginEdit();
  dr[0]["ProductName"] = txtEdit.Text;
  dr[0].EndEdit();
  SaveToSession(ds);
  GetProducts();

 }

</script>
<html>
 <body>
  <form runat="server">
   <TABLE CellPadding="4" CellSpacing="4" Border="0">

    <TR>
     <TD Style="font-size:18;background-color:green;color:white;text-align:center">

      Select A Supplier To Edit

     </TD>
    </TR>

    <TR>

     <TD Style="text-align:center">

      <b>Get All Products For</b>

      <asp:DropDownList
       id="DDLSuppliers"
       runat="server"
       DataTextField="CompanyName"
       DataValueField="SupplierID" />

      <b>Sort Results by </b>

      <asp:DropDownList id="DDLColumn" runat="Server" >
       <asp:ListItem Value="ProductID" Text="Product ID" />
       <asp:ListItem Value="ProductName" Text="Product Name" />
      </asp:DropDownList>

      <b> in </b>

      <asp:DropDownList id="DDLSortOrder" runat="Server" >
       <asp:ListItem Value="DESC" Text="DESC" />
       <asp:ListItem Value="ASC" Text="ASC" />
      </asp:DropDownList>

      <b>Order</b>

     </TD>
    </TR>

    <TR>

     <TD Style="text-align:left">

      <asp:Button
       Text="Get Products" Width="200"
       BackColor="green" ForeColor="White"
       OnClick="GetProducts_Click" Runat="server"
       Font-Bold="true" Border="none" />

     </TD>
    </TR>

    <TR>
     <TD Style="font-size:18;background-color:green;color:white;text-align:left">

      Edit Products

     </TD>
    </TR>

    <TR>
     <TD Style="text-align:left">

      <b>Choose Product From List to Edit or Delete</b>
      <br>
      <asp:ListBox
       Id="lbProducts" Runat="server"
       Rows="5" Width="100%"
       DataTextField="ProductName" DataValueField="ProductID" />
      <BR>
      <b>Edit or Insert Product </b><font size="1">{insert item by filling out textbox and clicking on the insert button}</font>
      <BR>
      <asp:TextBox
       Id="txtEdit" Runat="server"
       Width="100%"/>

     </TD>
    </TR>


    <TR>
     <TD Style="text-align:left">

      <asp:Button
       Id="Delete"
       Runat="Server" Text="Delete"
       OnClick="Delete_Click" Width="200"
       BackColor="green" ForeColor="White"
       Runat="server"  Font-Bold="true"
       Border="none" />
      <asp:button
       Id="Edit" Runat="server"
       Text="Edit" OnClick="Edit_Click"
       Width="200" BackColor="green"
       ForeColor="White" Runat="server"
       Font-Bold="true" Border="none" />
      <asp:button
       Id="Insert" Runat="server"
       Text="Insert" OnClick="Insert_Click"
       Width="200" BackColor="green"
       ForeColor="White" Runat="server"
       Font-Bold="true" Border="none" />
      <p>
      <a href="listing11.15.aspx">Save Changes</a>

     </TD>
    </TR>

   </TABLE>
  </form>
 </body>
</html>