<%@ Page Language="C#" %>
<%@ Register TagPrefix="bigcheese" TagName="top" Src="user_controls/top.ascx" %>
<%@ Register TagPrefix="bigcheese" TagName="copyright" Src="user_controls/copyright.ascx" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="Northwind.ProductServices" %>
<script runat="server">
 protected void Page_Load(Object sender, EventArgs e){
  if(!IsPostBack){
   DateTime dt = DateTime.Today;
   dt = dt.AddDays(7);
   Northwind.ProductServices.ProductServices NWND_Products = new Northwind.ProductServices.ProductServices();
   DataSet getProducts = NWND_Products.GetProducts(1);

   RequiredDate.SelectedDate = dt;
   RequiredDate.VisibleDate = dt;

   PlaceOrder.Visible = true;
   FinalOrder.Visible = false;
   Products.DataSource = getProducts.Tables["Products"].DefaultView;
   Products.DataBind();
  }
 }

 protected void Submit_Click(Object sender, EventArgs e){
  int OrderID = 0;

  // Create the DataSet to be passed to the Web Service
  DataSet CustomerOrder = new DataSet();

  // Add the required Order table to the DataSet
  CustomerOrder.Tables.Add("Order");

  // Add the ProductID and Quantity column to the Order table
  DataColumn ProductID = new  DataColumn();
  ProductID.DataType = System.Type.GetType("System.Int32");
  ProductID.ColumnName = "ProductID";
  CustomerOrder.Tables["Order"].Columns.Add(ProductID);

  DataColumn Quantity = new  DataColumn();
  Quantity.DataType = System.Type.GetType("System.Int32");
  Quantity.ColumnName = "Quantity";
  CustomerOrder.Tables["Order"].Columns.Add(Quantity);

  // Create the objects to be used in the for() loop
  DataRow newRow;
  TextBox ProductQuantity;
  int i = 0;
  int newQnty;
  int itemCount = 0;

  // Any item with a quantity greater than 0 should be added to the order
  for(i=0; i < Products.Items.Count-1; i++){
   ProductQuantity = (TextBox)Products.Items[i].FindControl("Qnty");
   newQnty = int.Parse(ProductQuantity.Text);

   if(newQnty > 0){
    newRow = CustomerOrder.Tables["Order"].NewRow();
    newRow["ProductID"] = int.Parse(Products.Items[i].Cells[0].Text);
    newRow["Quantity"] = newQnty;
    CustomerOrder.Tables["Order"].Rows.Add(newRow);
    itemCount = itemCount + 1;
   }
  }

  // Place the order by calling the Web Service if there are 1 or more items
  if(itemCount > 0){
   Northwind.ProductServices.ProductServices NWND_Products = new Northwind.ProductServices.ProductServices();

   // "THEBI" is the CustomerID for The Big Cheese.
   // This is the client page for The Big Cheese, so the value is hard coded.
   OrderID = NWND_Products.PlaceOrder("THEBI", RequiredDate.SelectedDate, 1, ShipName.Text, ShipAddress.Text, ShipCity.Text, ShipRegion.Text, ShipPostalCode.Text, ShipCountry.Text, CustomerOrder);

   ErrorMsg.Text = "Order Number: " + OrderID.ToString();

   GetNewOrder(OrderID);
Trace.Write("GetNewOrder", "Complete");
  }else{
   ErrorMsg.Text = "<H5>Error: No quantities over zero (0) were entered. Your order was not placed.</H5>";
  }
 }

 protected void GetNewOrder(int OrderID){
  DataSet OrderInfo;
  Northwind.ProductServices.ProductServices NWND_Products = new Northwind.ProductServices.ProductServices();
  OrderInfo = NWND_Products.GetOrderDetail(OrderID);

  Products.Visible = false;
  Submit.Visible = false;
  PlaceOrder.Visible = false;
  FinalOrder.Visible = true;

  FinalOrder.DataSource = OrderInfo.Tables["OrderDetail"].DefaultView;
  FinalOrder.DataBind();
 }
</script>
<html>
<head>
 <title>The Big Cheese - Order Form</title>
</head>
<body style="font: 8pt Verdana, Arial, sans-serif">
<form runat="server" method="post">
<bigcheese:top runat="server" Title="Beverage Order Form" />
<asp:Label runat="server" ID="ErrorMsg" EnableViewState="False" ForeColor="Red" Font-Bold="True" Width="740"  />
<table runat="server" ID="PlaceOrder" CellPadding="0" CellSpacing="0" Width="740">
 <tr>
  <td>
   <table cellpadding="4" cellspacing="0">
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To Name:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipName" Text="The Big Cheese - Store #7"
       Width="300" Font-Name="Verdana" Font-Size="9pt" />
     </td>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Date Required:</b></td>
    </tr>
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To Address:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipAddress" Text="123 Main Street"
       Width="300" Font-Name="Verdana" Font-Size="9pt" />
     </td>
     <td rowspan="5"style="font: 9pt Verdana, Arial, sans-serif">
      <asp:Calendar runat="server" ID="RequiredDate"
       TitleStyle-BackColor="Maroon" TitleStyle-ForeColor="White"
       TitleStyle-Font-Size="9pt" TitleStyle-Font-Bold="True"
       DayHeaderStyle-BackColor="Tan" DayHeaderStyle-ForeColor="Black"
       DayHeaderStyle-Font-Size="8pt" DayHeaderStyle-Font-Bold="True"
       DayStyle-BackColor="Tan" DayStyle-ForeColor="Black"
       DayStyle-Font-Size="8pt"
       SelectedDayStyle-BackColor="Maroon" SelectedDayStyle-ForeColor="White"
       Width="278"
      />
     </td>
    </tr>
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To City:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipCity" Text="Seattle"
       Width="300" Font-Name="Verdana" Font-Size="8pt" />
     </td>
    </tr>
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To Region:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipRegion" Text="WA"
       Width="300" Font-Name="Verdana" Font-Size="8pt" />
      </td>
    </tr>
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To Postal Code:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipPostalCode" Text="98101"
       Width="300" Font-Name="Verdana" Font-Size="8pt" />
     </td>
    </tr>
    <tr>
     <td style="font: 9pt Verdana, Arial, sans-serif"><b>Ship To Country:</b></td>
     <td>
      <asp:TextBox runat="server" id="ShipCountry" Text="USA"
       Width="300" Font-Name="Verdana" Font-Size="8pt" />
     </td>
    </tr>
   </table>
  </td>
 </tr>
 <tr>
  <td>
   <asp:DataGrid runat="server" ID="Products" AutoGenerateColumns="False"
    BorderWidth="1" BorderStyle="Solid" Gridlines="Both" BorderColor="Tan"
    Cellpadding="2" CellSpacing="0" Width="740"
    HeaderStyle-BackColor="Maroon"
    HeaderStyle-ForeColor="White"
    HeaderStyle-Font-Bold="True"
    HeaderStyle-Font-Name="Verdana"
    HeaderStyle-Font-Size="9pt"
    ItemStyle-Font-Name="Verdana"
    ItemStyle-Font-Size="8pt">
    <Columns>
     <asp:BoundColumn DataField="ProductID" HeaderText="SKU" />
     <asp:BoundColumn DataField="ProductName" HeaderText="Product Name" />
     <asp:BoundColumn DataField="QuantityPerUnit" HeaderText="Quantity/Unit" />
     <asp:BoundColumn DataField="UnitPrice" HeaderText="Unit Price" DataFormatString="{0:c}" ItemStyle-HorizontalAlign="Right" />
     <asp:TemplateColumn HeaderText="Quantity" ItemStyle-HorizontalAlign="Center">
      <ItemTemplate>
       <asp:TextBox runat="server" id="Qnty" Text="0" Width="50" Font-Size="8pt" Font-Name="Verdana" BorderStyle="Solid" BorderWidth="1" />
      </ItemTemplate>
     </asp:TemplateColumn>
    </Columns>
   </asp:DataGrid>
  </td>
 </tr>
 <tr>
  <td align="right">
   <asp:Button runat="server" ID="Submit" OnClick="Submit_Click" Text="Place Order" BorderStyle="Solid" BackColor="Maroon" ForeColor="White" Font-Bold="True" Font-Name="Verdana" Font-Size="9pt" style="cursor: hand;" />
  </td>
 </tr>
</table>
<asp:DataGrid runat="server" ID="FinalOrder" AutoGenerateColumns="False"
 BorderWidth="1" BorderStyle="Solid" Gridlines="Both" BorderColor="Tan"
 Cellpadding="2" CellSpacing="0" Width="740"
 HeaderStyle-BackColor="Maroon"
 HeaderStyle-ForeColor="White"
 HeaderStyle-Font-Bold="True"
 HeaderStyle-Font-Name="Verdana"
 HeaderStyle-Font-Size="9pt"
 ItemStyle-Font-Name="Verdana"
 ItemStyle-Font-Size="8pt">
 <Columns>
  <asp:BoundColumn DataField="ProductName" HeaderText="Product Name" />
  <asp:BoundColumn DataField="UnitPrice" HeaderText="Unit Price" DataFormatString="{0:c}" ItemStyle-HorizontalAlign="Right" />
  <asp:BoundColumn DataField="Quantity" HeaderText="Quantity" ItemStyle-HorizontalAlign="Center" />
  <asp:BoundColumn DataField="Discount" HeaderText="Discount" ItemStyle-HorizontalAlign="Center" />
  <asp:BoundColumn DataField="ExtendedPrice" HeaderText="Sub Total" DataFormatString="{0:c}" ItemStyle-HorizontalAlign="Right" />
 </Columns>
</asp:DataGrid>
<bigcheese:copyright runat="server" />
</form>
</body>
</html>